using SummaryRowsSample;
using Syncfusion.Data;
using Syncfusion.SfDataGrid;
using System;
using System.Collections.Generic;
using System.Text;
using UIKit;
using System.Linq;
using System.Threading.Tasks;
using System.Collections.ObjectModel;
using Foundation;
using CoreGraphics;

namespace SummaryDemo
{
    
    public class MyViewController : UIViewController
    {
        SfDataGrid datagrid;
        ViewModel viewModel;

		protected UIView popupContainer;

        public MyViewController()
        {

			UIButton loadGridButton = new UIButton();
			loadGridButton.SetTitle("Show Grid", UIControlState.Normal);
			this.View.Add(loadGridButton);
			this.View.BackgroundColor = UIColor.LightTextColor;

			loadGridButton.TranslatesAutoresizingMaskIntoConstraints = false;
			View.AddConstraint(NSLayoutConstraint.Create(View, NSLayoutAttribute.CenterX, NSLayoutRelation.Equal, loadGridButton, NSLayoutAttribute.CenterX, 1, 0));
			View.AddConstraint(NSLayoutConstraint.Create(View, NSLayoutAttribute.CenterY, NSLayoutRelation.Equal, loadGridButton, NSLayoutAttribute.CenterY, 1, 0));
			View.AddConstraint(NSLayoutConstraint.Create(loadGridButton, NSLayoutAttribute.Width, NSLayoutRelation.Equal, null, NSLayoutAttribute.NoAttribute, 1, 120));
			View.AddConstraint(NSLayoutConstraint.Create(loadGridButton, NSLayoutAttribute.Height, NSLayoutRelation.Equal, null, NSLayoutAttribute.NoAttribute, 1, 50));
				


			loadGridButton.TouchUpInside += delegate
			{
				popupContainer = new UIView();

				popupContainer.TranslatesAutoresizingMaskIntoConstraints = false;
				popupContainer.BackgroundColor = UIColor.Blue.ColorWithAlpha(0.1f);

				View.Add(popupContainer);
				View.AddConstraint(NSLayoutConstraint.Create(View, NSLayoutAttribute.CenterX, NSLayoutRelation.Equal, popupContainer, NSLayoutAttribute.CenterX, 1, 0));
				View.AddConstraint(NSLayoutConstraint.Create(View, NSLayoutAttribute.CenterY, NSLayoutRelation.Equal, popupContainer, NSLayoutAttribute.CenterY, 1, 0));
				View.AddConstraint(NSLayoutConstraint.Create(View, NSLayoutAttribute.Width, NSLayoutRelation.Equal, popupContainer, NSLayoutAttribute.Width, 1, 0));
				View.AddConstraint(NSLayoutConstraint.Create(View, NSLayoutAttribute.Height, NSLayoutRelation.Equal, popupContainer, NSLayoutAttribute.Height, 1, 0));
				



				datagrid = new SfDataGrid();
				datagrid.AllowSorting = true;
				viewModel = new ViewModel();
				datagrid.AutoGenerateColumns = false;
				datagrid.ColumnSizer = ColumnSizer.None;
				datagrid.AllowTriStateSorting = true;
				datagrid.GridStyle.AlternatingRowColor = UIColor.FromRGB(230, 230, 230);

				datagrid.CellRenderers.Remove("HeaderView");
				datagrid.CellRenderers.Add("HeaderView", new WrappingSyncHeaderCellRenderer());

				//datagrid.GroupColumnDescriptions.Add(new GroupColumnDescription() { ColumnName = "Description" });

	   //         GridSummaryRow summaryRow = new GridSummaryRow();
				//summaryRow.ShowSummaryInRow = false;

				//GridSummaryColumn summary = new GridSummaryColumn();
				//summary.Name = "Paid";
				//summary.MappingName = "Paid";
				//summary.Format = "{Sum:c}";
				//summary.SummaryType = SummaryType.DoubleAggregate;

				//GridSummaryColumn summary1 = new GridSummaryColumn();
				//summary1.Name = "Incurred";
				//summary1.MappingName = "Incurred";
				//summary1.Format = "{Sum:c}";
				//summary1.SummaryType = SummaryType.DoubleAggregate;

				//GridSummaryColumn summary2 = new GridSummaryColumn();
				//summary2.Name = "Reserves";
				//summary2.MappingName = "Reserves";
				//summary2.Format = "{Sum:c}";
				//summary2.SummaryType = SummaryType.DoubleAggregate;

				//summaryRow.SummaryColumns.Add(new GridSummaryColumn
				//{
				//	Name = "Description",
				//	CustomAggregate = new CustomAggregate(),
				//	MappingName = "Description",
				//	Format = "{totalSum}",
				//	SummaryType = Syncfusion.Data.SummaryType.Custom
				//});

				//GridSummaryColumn summary4 = new GridSummaryColumn();
				//summary4.Name = "Code";
				//summary4.MappingName = "Code";
				//summary4.Format = "{Count}"+"Count";
				//summary4.SummaryType = SummaryType.CountAggregate;

				//summaryRow.SummaryColumns.Add(summary);
				//summaryRow.SummaryColumns.Add(summary1);
				//summaryRow.SummaryColumns.Add(summary2);
				//summaryRow.SummaryColumns.Add(summary4);

	   //         datagrid.CaptionSummaryRow = summaryRow;

				GridTextColumn codeCol = new GridTextColumn();
				codeCol.MappingName = "Code";
	            codeCol.HeaderText = "Code";
				SetColWidth(codeCol, true);

	            GridTextColumn descCol = new GridTextColumn();
				descCol.MappingName = "Description";
	            descCol.HeaderText = "Longer Description";
				SetColWidth(descCol, false);

	            GridTextColumn paidCol = new GridTextColumn();
				paidCol.MappingName = "Paid";
	            paidCol.HeaderText = "Paid Amount";
				SetColWidth(paidCol, false);

	            GridTextColumn incurredCol = new GridTextColumn();
				incurredCol.MappingName = "Incurred";
	            incurredCol.HeaderText = "Incurred Amount";
				SetColWidth(incurredCol, true);

				//GridTextColumn reservesCol = new GridTextColumn();
				//reservesCol.MappingName = "Reserves";
	   //         reservesCol.HeaderText = "Remaining Reserves";
				//SetColWidth(reservesCol, false);

				//GridTextColumn xCode = new GridTextColumn();
				//xCode.MappingName = "XCode";
	   //         xCode.HeaderText = "X Code";
				//SetColWidth(xCode, true);

				//GridTextColumn yCode = new GridTextColumn();
				//yCode.MappingName = "YCode";
	   //         yCode.HeaderText = "Y Code";
				//SetColWidth(yCode, false);

				//GridTextColumn zCode = new GridTextColumn();
				//zCode.MappingName = "ZCode";
	   //         zCode.HeaderText = "Z Code";
				//SetColWidth(zCode, true);

				datagrid.Columns.Add(codeCol);
				datagrid.Columns.Add(descCol);
				datagrid.Columns.Add(paidCol);
				datagrid.Columns.Add(incurredCol);
				//datagrid.Columns.Add(reservesCol);
				//datagrid.Columns.Add(xCode);
				//datagrid.Columns.Add(yCode);
				//datagrid.Columns.Add(zCode);

				datagrid.QueryRowHeight += Grid_QueryRowHeight;

				popupContainer.AddSubviews(datagrid);
				datagrid.TranslatesAutoresizingMaskIntoConstraints = false;
				datagrid.BackgroundColor = UIColor.Clear;
			
				popupContainer.AddConstraint(NSLayoutConstraint.Create(this.popupContainer, NSLayoutAttribute.CenterX, NSLayoutRelation.Equal, datagrid, NSLayoutAttribute.CenterX, 1, 0));
				popupContainer.AddConstraint(NSLayoutConstraint.Create(this.popupContainer, NSLayoutAttribute.CenterY, NSLayoutRelation.Equal, datagrid, NSLayoutAttribute.CenterY, 1, 0));
				popupContainer.AddConstraint(NSLayoutConstraint.Create(this.popupContainer, NSLayoutAttribute.Width, NSLayoutRelation.Equal, datagrid, NSLayoutAttribute.Width, 1, 30));
				popupContainer.AddConstraint(NSLayoutConstraint.Create(this.popupContainer, NSLayoutAttribute.Height, NSLayoutRelation.Equal, datagrid, NSLayoutAttribute.Height, 1, 80));

				datagrid.ItemsSource = new ObservableCollection<OrderInfo>();
				BeginInvokeOnMainThread(() => DelayedLoad());

			};

            


        }

		void SetColWidth(GridTextColumn col, bool testShouldStar)
		{
			if (!testShouldStar)
			{

				col.Width = 200;//adding 15 for additional padding
			}
			else
			{
				col.ColumnSizer = ColumnSizer.Star;//if we don't specify, let the column size itself
			}

		}

		void Grid_QueryRowHeight(object sender, QueryRowHeightEventArgs e)
		{
			if (e.RowIndex > 0)
			{
				double height = SfDataGridHelpers.GetRowHeight(datagrid, e.RowIndex);
				e.Height = height;
				e.Handled = true;

			}
		}

		private async Task DelayedLoad()
		{
			await Task.Delay(2000);

			datagrid.ItemsSource = viewModel.OrdersInfo;
		}
        //public override void ViewDidLayoutSubviews()
        //{
        //    //datagrid.Frame = new CoreGraphics.CGRect(0, 0, View.Frame.Width, View.Frame.Height );
        //    base.ViewDidLayoutSubviews();
        //}
    }
	public class CustomAggregate : ISummaryAggregate
	{
		public CustomAggregate()
		{ 
			
		}
		public double totalSum { get; set; }
		public Action<System.Collections.IEnumerable, string, System.ComponentModel.PropertyDescriptor> CalculateAggregateFunc()
		{
			return (items, property, pd) =>
			 {
				 var enumerableItems = items as IEnumerable<OrderInfo>;
				 if (pd.Name == "totalSum")
				 {
					this.totalSum = enumerableItems.totalSum<OrderInfo>(q=>q.Incurred+q.Paid+q.Reserves);
				 }
			 };
		}
	}
	public static class LinqExtensions
	{
		public static double totalSum<T>(this IEnumerable<T> values, Func<T, double?> selector)
		{
			double sum = 0;
			var count = values.Count();
			foreach (var v in values )
			{
				OrderInfo a = v as OrderInfo;
				 sum =  sum +a.Paid+a.Incurred+a.Reserves;
			}
	 			return sum;
		}
	}
}
